#!/usr/bin/env python
# -*- coding: utf-8 -*-
import os,sys,time,md5
from sh import sh,rehash

#alreadywroteline = 0
def output(st):
    #global alreadywroteline
    #if alreadywroteline: sys.stdout.write("\n")
    sys.stdout.write(st+"\n")

def find_master():
    fl = os.listdir(".")
    for i in xrange(len(fl)):
        # The following is for dangling symlinks:
        try: fl[i] = (fl[i],os.stat(fl[i]).st_mtime)
        except: fl[i] = (fl[i],0)
    # For Python 2.4 (more efficient):
    # fl.sort(key=lambda a: a[1],reverse=1)
    fl.sort(lambda a,b: cmp(b[1],a[1]))
    # Now find the first .tex file having a "documentclass":
    i = 0
    master = ""
    while i < len(fl):
        if fl[i][0][-4:] == '.tex':
            f = file(fl[i][0])
            li = f.readlines()
            f.close()
            j = 0
            k = 0
            found = 0
            while j < len(li) and k < 30 and not(found):
                if li[j][0] != '%':
                    k += 1
                    if li[j].find('\\documentclass') >= 0:
                        found = 1
                j += 1
            del li
            if found:
                master = fl[i][0]
                break
        i += 1
    if master == "":
        print "No master file found."
        sys.exit(1)
    return master

    
def parse_aux(aux):
    idxfile = aux[:-3]+"idx"
    if not(os.path.exists(idxfile)):
        idxfile = None
        
    try:
        f = file(aux)
        l = f.readlines()
        f.close()
    except:
        return ([aux],[],[],idxfile)    # aux-, bib-, toc-files, idx-file

    auxfiles = [aux]
    bibfiles = []
    tocfiles = []
    for li in l:
        if li[:8] == '\\@input{':
            p = li.find('}')
            if p >= 0:
                auxfiles.append(li[8:p])
        elif li[:9] == '\\bibdata{':
            p = li.find('}')
            if p >= 0:
                bibfiles.append(li[9:p]+".bib")
        elif li[:12] == '\\@writefile{':
            p = li.find('}')
            if p >= 0:
                tocfiles.append(aux[:-3]+li[12:p])
    return (auxfiles,bibfiles,tocfiles,idxfile)

def calc_md5sums(fi,parse_citations=0):
    sums = []
    cite = md5.new()
    for fn in fi:
        try:
            f = file(fn)
            l = f.readlines()
            f.close()
        except:
            sums.append("")
            continue
        sum = md5.new()
        if parse_citations:
            for li in l:
                if li.find("\\citation{") >= 0:
                # this is no longer good: li.find("\\bibcite{") >= 0:
                    cite.update(li)
                sum.update(li)
        else:
            for li in l:
                sum.update(li)
        sums.append(sum.hexdigest())
    if parse_citations:
        return (sums,cite.hexdigest())
    else:
        return sums

